VERSION 5.00
Begin VB.Form ViewerForm 
   Caption         =   "ListWords []"
   ClientHeight    =   5685
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   8715
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5685
   ScaleWidth      =   8715
   Begin VB.TextBox txtResults 
      Height          =   1455
      Left            =   2280
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   4
      Top             =   0
      Width           =   2415
   End
   Begin VB.ComboBox PatternCombo 
      Height          =   315
      ItemData        =   "ListWords.frx":0000
      Left            =   0
      List            =   "ListWords.frx":0002
      TabIndex        =   3
      Text            =   "Combo1"
      Top             =   3600
      Width           =   2175
   End
   Begin VB.DriveListBox DriveList 
      Height          =   315
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   2175
   End
   Begin VB.DirListBox DirList 
      Height          =   1155
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   2175
   End
   Begin VB.FileListBox FileList 
      Height          =   1845
      Left            =   0
      TabIndex        =   0
      Top             =   1560
      Width           =   2175
   End
End
Attribute VB_Name = "ViewerForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' The currently displayed file.
Private m_FileName As String

' For deleting files.
Private Type SHFILEOPSTRUCT
    hwnd As Long
    wFunc As Long
    pFrom As String
    pTo As String
    fFlags As Integer
    fAnyOperationsAborted As Long
    hNameMappings As Long
    lpszProgressTitle As Long '  only used if FOF_SIMPLEPROGRESS
End Type
Private Declare Function SHFileOperation Lib "shell32.dll" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long
Private Const FO_DELETE = &H3
Private Const FOF_ALLOWUNDO = &H40
Private Const FOF_NOCONFIRMATION = &H10             '  Don't prompt the user.
' Return a sorted list of the words in this file.
Private Function GetFileWords(ByVal file_name As String) As String
Dim file_contents As String

    If Right$(file_name, 4) = ".doc" Then
        ' Read as a Word document.
        file_contents = GrabWordFile(file_name)
    Else
        file_contents = GrabTextFile(file_name)
    End If

    GetFileWords = GetWords(file_contents)
End Function
' Return a text file's contents.
Private Function GrabTextFile(ByVal file_name As String) As String
Dim fnum As Integer

    fnum = FreeFile
    Open file_name For Input As #fnum
    GrabTextFile = Input$(LOF(fnum), #fnum)
    Close #fnum
End Function


' Read the text contents of a Word file.
Private Function GrabWordFile(ByVal file_name As String) As String
Const OPEN_FORMAT_AUTO = 0
Dim word_server As Object ' Word.Application

    ' Start the Word server.
    Set word_server = CreateObject("Word.Application")

    ' Open the file.
    word_server.Documents.Open _
        FileName:=file_name, _
        ConfirmConversions:=False, _
        ReadOnly:=False, _
        AddToRecentFiles:=False, _
        PasswordDocument:="", _
        PasswordTemplate:="", _
        Revert:=False, _
        WritePasswordDocument:="", _
        WritePasswordTemplate:="", _
        Format:=OPEN_FORMAT_AUTO

    ' Return the document's text.
    GrabWordFile = word_server.ActiveDocument.Content.Text

    ' Close the document without prompting.
    word_server.ActiveDocument.Close False
    word_server.Quit
End Function
' Return a sorted list of the string's words.
Private Function GetWords(ByVal file_contents As String) As String
Dim i As Integer
Dim ch As String
Dim word_array() As String
Dim word_col As Collection
Dim Word As String
Dim result As String

    ' Replace separator characters with spaces.
    For i = 1 To Len(file_contents)
        ' See if this character is a letter or number.
        ch = Mid$(file_contents, i, 1)
        If Not ( _
            (ch >= "A" And ch <= "Z") Or _
            (ch >= "a" And ch <= "z") Or _
            (ch >= "0" And ch <= "9") _
        ) Then
            ' Not a letter. Replace with space.
            Mid$(file_contents, i, 1) = " "
        End If
    Next i
    file_contents = LCase$(file_contents)

    ' Split the words.
    word_array = Split(file_contents)

    ' Add the words to the word collection.
    Set word_col = New Collection
    On Error Resume Next
    For i = LBound(word_array) To UBound(word_array)
        Word = word_array(i)
        If Len(Word) > 0 Then word_col.Add Word, Word
    Next i
    On Error GoTo 0

    ' Convert the collection into an array.
    ReDim word_array(1 To word_col.Count)
    For i = 1 To word_col.Count
        word_array(i) = word_col(i)
    Next i

    ' Sort the array.
    Quicksort word_array, 1, word_col.Count

    ' Generate the result string.
    result = ""
    For i = 1 To word_col.Count
        result = result & vbCrLf & word_array(i)
    Next i

    GetWords = Mid$(result, Len(vbCrLf) + 1)
End Function
' Use Quicksort to sort a list of strings.
'
' This code is from the book "Ready-to-Run
' Visual Basic Algorithms" by Rod Stephens.
' http://www.vb-helper.com/vba.htm
Private Sub Quicksort(list() As String, ByVal min As Long, ByVal max As Long)
Dim mid_value As String
Dim hi As Long
Dim lo As Long
Dim i As Long

    ' If there is 0 or 1 item in the list,
    ' this sublist is sorted.
    If min >= max Then Exit Sub

    ' Pick a dividing value.
    i = Int((max - min + 1) * Rnd + min)
    mid_value = list(i)

    ' Swap the dividing value to the front.
    list(i) = list(min)

    lo = min
    hi = max
    Do
        ' Look down from hi for a value < mid_value.
        Do While list(hi) >= mid_value
            hi = hi - 1
            If hi <= lo Then Exit Do
        Loop
        If hi <= lo Then
            list(lo) = mid_value
            Exit Do
        End If

        ' Swap the lo and hi values.
        list(lo) = list(hi)

        ' Look up from lo for a value >= mid_value.
        lo = lo + 1
        Do While list(lo) < mid_value
            lo = lo + 1
            If lo >= hi Then Exit Do
        Loop
        If lo >= hi Then
            lo = hi
            list(hi) = mid_value
            Exit Do
        End If

        ' Swap the lo and hi values.
        list(hi) = list(lo)
    Loop

    ' Sort the two sublists.
    Quicksort list, min, lo - 1
    Quicksort list, lo + 1, max
End Sub
Private Sub DirList_Change()
    FileList.Path = DirList.Path
End Sub

Private Sub DriveList_Change()
    'On Error GoTo DriveError
    DirList.Path = DriveList.Drive
    Exit Sub

DriveError:
    DriveList.Drive = DirList.Path
    Exit Sub
End Sub


Private Sub FileList_Click()
    m_FileName = FileList.Path
    If Right$(m_FileName, 1) <> "\" Then m_FileName = m_FileName & "\"
    m_FileName = m_FileName & FileList.FileName
    Caption = "ListWords [" & m_FileName & "]"

    txtResults.Text = GetFileWords(m_FileName)
End Sub
' Process keypresses.
' Delete    - Move the file into the wastebasket.
' Backspace - Kill the file.
' F5        - Hide/show the file selection controls.
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
Dim op As SHFILEOPSTRUCT

    On Error GoTo KeyError
    If KeyCode = vbKeyDelete Then
        ' Move the file into the wastebasket.
        With op
            .wFunc = FO_DELETE
            .pFrom = FileList.Path & "\" & FileList.FileName
            .fFlags = _
                FOF_ALLOWUNDO Or _
                FOF_NOCONFIRMATION
        End With
        SHFileOperation op

        txtResults.Text = ""
    ElseIf KeyCode = vbKeyBack Then
        ' Delete the file permanently.
        Kill FileList.Path & "\" & FileList.FileName

        txtResults.Text = ""
    End If
    Exit Sub

KeyError:
    MsgBox "Error " & Format$(Err.Number) & _
        vbCrLf & Err.Description
    Exit Sub
End Sub

Private Sub Form_Load()
    KeyPreview = True

    PatternCombo.AddItem "Text (*.txt)"
    PatternCombo.AddItem "Doc (*.doc)"
    PatternCombo.AddItem "All Files (*.*)"
    PatternCombo.ListIndex = 2
End Sub

Private Sub Form_Resize()
Dim wid As Integer
Dim hgt As Integer

    If WindowState = vbMinimized Then Exit Sub

    wid = DriveList.Width
    DriveList.Move 0, 0
    PatternCombo.Move 0, ScaleHeight - PatternCombo.Height, wid

    hgt = (PatternCombo.Top - DriveList.Top - DriveList.Height) / 2
    If hgt < 100 Then hgt = 100
    DirList.Move 0, DriveList.Top + DriveList.Height, wid, hgt
    FileList.Move 0, DirList.Top + DirList.Height, wid, hgt

    wid = ScaleWidth - wid
    If wid < 120 Then wid = 120
    txtResults.Move DriveList.Width, 0, wid, ScaleHeight
End Sub

Private Sub PatternCombo_Click()
Dim pat As String
Dim p1 As Integer
Dim p2 As Integer

    pat = PatternCombo.list(PatternCombo.ListIndex)
    p1 = InStr(pat, "(")
    p2 = InStr(pat, ")")
    FileList.Pattern = Mid$(pat, p1 + 1, p2 - p1 - 1)
End Sub
